/*  wx_button version 1.1

    This file is part of the WidgetX library
    http://www.dynamic-core.net
*/

function wx_button(x,y,w,h,caption,theme) {
	this.id = "wx_button"+(wx_button.Count++)
	this.object = this.id + "Obj"
	eval(this.object + "=this")
	
	this.moveTo(x||0,y||0)
	this.setSize(w||128,h||36)
	
	this.theme=theme||''
	this.lcaption=new DynLayer()
	this.caption=caption||''
	this.lcaption.setVisible(true)
	this.levents=new DynLayer()
	this.levents.setVisible(true)
	
	this.setVisible(false)

	return this
}
wx_button.Count=0
wx_button.prototype = new DynLayer
wx_button.prototype.getSubClas=function() { return wx_button }
wx_button.prototype.onClick=function() {}
wx_button.prototype.onRelease=function() {}
wx_button.prototype.buttonup='button-up.gif'
wx_button.prototype.buttondown='button-down.gif'
wx_button.prototype.buttonselected='button-selected.gif'
wx_button.prototype.setCaption=function(caption) { 
		this.caption=caption
		this.lcaption.setHTML('<span class="default">'+this.caption+'</span>') 
	}
wx_button.prototype.onCreate=function() {
		this.setHTML('<img src="'+this.theme+this.buttonup+'" name="'+this.id+'btn"width="'+this.w+'" height="'+this.h+'">')
		this.lcaption.moveTo(2,2)
		this.lcaption.setSize(this.w-4,this.h-4)
		this.levents.moveTo(0,0)
		this.levents.setSize(this.w,this.h)

		this.lcaption.setHTML('<span class="default">'+this.caption+'</span>')

		this.events=new EventListener(this)
		this.events.onmousedown=function(e) {
			me=e.getTarget()
			me.doc.images[me.id+"btn"].src = me.theme+me.buttondown
			me.onClick()
			e.setBubble(false)
		}
		this.events.onmouseup=function(e) {
			me=e.getTarget()
			me.doc.images[me.id+"btn"].src = me.theme+me.buttonup
			me.onRelease()
			e.setBubble(false)
		}
		this.events.onmouseover=function(e) {
			me=e.getTarget()
			me.doc.images[me.id+"btn"].src = me.theme+me.buttonselected
			e.setBubble(false)
		}
		
		this.levents.addEventListener(this.events)
		
		this.addChild(this.lcaption)
		this.addChild(this.levents)
	}
