// Session Management Functions
// handles the passing of variables between pages using file.html?variable=x
// 19991209

// Copyright (C) 1999 Robert Rainwater (rainwater@mail.com)
// Distributed under the terms of the GNU Library General Public License
// Available at http://www.dansteinman.com/dynapi/

// Thanks to: noah (noah@mailcity.com)

var sessionArgs = new Array()
var sessionParams = new Array()

function getVal(val) {
	if (val == 'true' || val == 'false') return eval(val)
	for (var i=0;i < val.length;i++) {
		if ((val.substring(i,i+1) < '0') || (val.substring(i,i+1) > '9')) return val
	}
	return eval(val)        
}

function updateArg(par,val) {
	if (!sessionArgs[escape(par)]) sessionParams[sessionParams.length] = escape(par)
	sessionArgs[escape(par)] = escape(val)
}

function sessionInit() {
	params = document.location.href
	if (params.indexOf('?') != -1) {
		params = params.substr(params.indexOf('?')+1,params.length)
		if (params.indexOf('&') != -1) {
			params = params.split('&')
			for (var i=0; i < params.length; ++i) {
				if (params[i].indexOf('=') != -1) {
					str = params[i].split('=')
					updateArg(str[0],str[1])
				}
			}
		}
		else {
			if (params.indexOf('=') != -1) {
				params = params.split('=')
				updateArg(params[0],params[1])
			}
		}
	}
	args = sessionInit.arguments
	if (args.length > 0) {
		for (var i=0; i < args.length; i+=2) {
			updateArg(args[i],args[i+1])
		}
	}
}

function sessionURL(url) {
	for (var i=1; i<sessionURL.arguments.length; i+=2)
		updateArg(sessionURL.arguments[i],sessionURL.arguments[i+1])
	str = sessionURL.arguments[0]
	if (sessionParams.length > 0) {
		str += '?'
		for (var i=0; i<sessionParams.length; ++i) {
			if (i != sessionParams.length-1)
				str += escape(sessionParams[i])+'='+escape(sessionArgs[sessionParams[i]])+'&'
			else
				str += escape(sessionParams[i])+'='+escape(sessionArgs[sessionParams[i]])
		}
	}
	return str
}

function sessionGo(url) {
	for (var i=1; i<arguments.length; i+=2) updateArg(arguments[i],arguments[i+1])
	document.location.href = sessionURL(url)
}
